; 					Include for: Proj_Dir\LCD_Key_Enc\LCD_Task.Asm
;Encoder	;    ,    
;#include Proj_Dir\LCD_Key_Enc\Encoder_Sub.inc	; Encod   .
;	return

;;    -    
; 08/07/2017           

;Encoder	;    ,    
;          
;	movf	PortB_Buf,W,ACCESS	; 
	movf	Encoder_Bits,W,BANKED	; 

	andlw	b'11000000'			;   

	btfsc	WREG,7,ACCESS		;  
	btg		WREG,6,ACCESS		;   
	CPFSEQ	Encoder_Old,BANKED	; 
	bra		EncoderDone1			;
		return	;
EncoderDone1
	CPFSLT	Encoder_Old,BANKED		;    
		bra		EncLt				;
;	bcf		BeeperPin	;   ""   
	decf	Encoder_Temp,F,BANKED	;    
	movlw	0x80-Encoder_Step	;
	CPFSLT	Encoder_Temp,BANKED	;					;
		bra		EncoderExit		;

	Beeper 0x4	;  ;  500 
 #ifdef LCD_Work_Present
	btfss	LCD_Flg1,3,ACCESS	;  / 
	clrf	LcdWorkTime,ACCESS		; - - 
 #endif	
	movlf	0x80,Encoder_Temp,BANKED;     
 #ifdef LCD_Work_Present
	btfsc	LCD_Flg1,3,ACCESS	;  / 
		bra		WorkParameterDecrement	;        
 #endif
	
	btfsc	Flag1,0,ACCESS		;  /
		bra		ParameterDecrement	;******************************
	
	bcf		Flag1,3,ACCESS	;    
	decf	Encoder_Count,F,ACCESS	;  
	btfsc	_C					;  
		bra		DoneEnc				;
	movlf	ParametrNum-1,Encoder_Count,ACCESS	;     

		bra		DoneEnc				;
EncLt
;	CPFSLT	Encoder_Old,BANKED		;    

	incf	Encoder_Temp,F,BANKED;
	movlw	0x80+Encoder_Step	;
	CPFSGT	Encoder_Temp,BANKED	;					;
		bra		EncoderExit		;

	Beeper 0x8	;  ;  500 
 #ifdef LCD_Work_Present
	btfss	LCD_Flg1,3,ACCESS	;  / 
	clrf	LcdWorkTime,ACCESS		; - - 
 #endif
	movlf	0x80,Encoder_Temp,BANKED;     
 #ifdef LCD_Work_Present
	btfsc	LCD_Flg1,3,ACCESS	;  / 
 	bra		WorkParameterIncrement	;        
 #endif
	btfsc	Flag1,0,ACCESS			;  /
		bra		ParameterIncrement	; ******************************

	bcf		Flag1,3,ACCESS	;    
	incf	Encoder_Count,F,ACCESS	;
	movlw	ParametrNum			;
	CPFSLT	Encoder_Count,ACCESS;
	clrf	Encoder_Count,ACCESS;
		bra		DoneEnc				;	;
;********************   **************
ParameterDecrement	
	movff	FSR0L,FSR0L_Temp	;
	movff	FSR0H,FSR0H_Temp	;

;	clrf	FSR0H,ACCESS		;
	movff16	ParAdr,FSR0L		; 25/03/2017    
	movf	ParMin,W,BANKED		;    
	btfss	Flag1,4,ACCESS		;  "  "
	CPFSEQ	INDF0,ACCESS		;    -   
		decf	INDF0,F,ACCESS	;
	bra		RestFSR0
 #ifdef LCD_Work_Present
WorkParameterDecrement	;      1  
 #ifdef	PCPWM_Present
	PCPWM_Page
	movlw	0x00;,W,ACCESS		;     
;	btfss	Flag1,4,ACCESS		;  "  "
	CPFSEQ	PCPWM_WrkSpdBuf,BANKED		;    -   
		decf	PCPWM_WrkSpdBuf,F,BANKED	;PCPWM_Speed
	LCD_BANK
 #endif
			bra		EncoderExit		;return; bra		DoneButt;DoneEnc			;
WorkParameterIncrement	
 #ifdef	PCPWM_Present
	PCPWM_Page
	movlw	0xFF;,W,ACCESS		;     
;	btfss	Flag1,4,ACCESS		;  "  "
	CPFSEQ	PCPWM_WrkSpdBuf,BANKED		;    -   
		incf	PCPWM_WrkSpdBuf,F,BANKED	;PCPWM_Speed

		;infsnz	PCPWM_Speed,F,BANKED	;
		;	decf	PCPWM_Speed,F,BANKED;
	LCD_BANK
 #endif
		bra		EncoderExit		;
 #endif	;#ifdef LCD_Work_Present
ParameterIncrement	
	movff	FSR0L,FSR0L_Temp	;
	movff	FSR0H,FSR0H_Temp	;

;	clrf	FSR0H,ACCESS		;
	movff16	ParAdr,FSR0L		; 25/03/2017    

	movf	ParMax,W,BANKED		;    
	btfss	Flag1,4,ACCESS		;  "  "
	CPFSEQ	INDF0,ACCESS		;    -   
		incf	INDF0,F,ACCESS	;
;******************    *************
RestFSR0
; 05/03/2020  DTCON  DTCON_Buf  
 movlw	d'21'	;      "DeadTimeDTCON"
 subwf	Encoder_Count,W,ACCESS;
#ifdef	PCPWM_Present
 btfsc	_Z	;
	movff	DtConBuf,DTCON		;  DTCON  DTCON_Buf  
#endif

	movff	FSR0L_Temp,FSR0L	;-
	movff	FSR0H_Temp,FSR0H	;
	bra		DoneEnc				;
DoneEnc
;   ParametrNum
	movf	Encoder_Count,W,ACCESS	;  
	addlw	ParamDelta	;     
 LcdOutStr	0x2	;   
EncoderExit		;
;	movf	PortB_Buf,W,ACCESS		;
	movf	Encoder_Bits,W,BANKED	;  14/01/2020 

	andlw	b'11000000'			;   
	btfsc	WREG,7,ACCESS		;  
	btg		WREG,6,ACCESS		;   
	movwf	Encoder_Old,BANKED	;

		return;
