;   LCD_Task.asm  ~ 343
		bra RAM_Cmd_Bra	;   ~  
;    / :
RAM_Cmd_0x10		;    - 2 
	movlw	d'2'	;   
;	rcall	Format_RAM	;       
 	rcall	Format_RAM_W;         
;    Format_Buf -     ,   
;   Ram_Str_Buf      LCD.
;   -   FSR0 (   )
;     .
	lfsr	0,Ram_Str_Buf_0	;       
	movff	Format_Buf,Tmp_0	;     .
	rcall	Hex_Byte_Sub	;      
		bra	RAM_Str	;       

RAM_Cmd_0x18		;    - 1 
	movlw	d'1'	;   
;	rcall	Format_RAM	;       
;    Format_Buf -     ,   
;   Ram_Str_Buf      LCD.
;   -   FSR0 (   )
;     .
;       /
	movwf	RAM_Count,BANKED;   
	movlf	0x3A,Porog_9_A,BANKED;    9    .
	bsf		LCD_Flg,7,ACCESS;       

	rcall	Read_ROM_Byte	;      
	movff	TABLAT,FSR0L	; 
  
	btfsc	Flag1,2,ACCESS	;     ?
	movff	TABLAT,ParAdr	;  

	rcall	Read_ROM_Byte	;      
	movff	TABLAT,FSR0H	;  
 
	btfsc	Flag1,2,ACCESS	;     ?
	movff	TABLAT,ParAdr+1	;  

 	bcf		Flag1,2,ACCESS	;      ?

	movff	POSTINC0,Format_Buf		;  1  
;	movff	POSTINC0,Format_Buf+1	;   
;	lfsr	0,Ram_Str_Buf	;       
	movlf	low(Ram_Str_Buf_0),RAM_Str_Ptr,BANKED;   
	movlf	high(Ram_Str_Buf_0),RAM_Str_Ptr+1,BANKED; . 

	lfsr	0,Ram_Str_Buf_0	;       
	movff	Format_Buf,Tmp_0	;     .

;           1 
;	swapf	Tmp_0,W,BANKED			;    .
	movf	Tmp_0,W,BANKED			;   

	rcall	Hex_Nible_Sub	;  1  WREG   

;	infsnz	RAM_Str_Ptr,F,BANKED	;    
							;     
;	incf	RAM_Str_Ptr+1,F,BANKED	;   -     

;	bra		RAM_Str	;       
;RAM_Str		;      LCD,  LCD  .
	bcf		Flag1,2,ACCESS		;     
	movff16	RAM_Str_Ptr,FSR0L	;     
	dcfsnz 	RAM_Count,F,BANKED	;     
	bcf		LCD_Flg,7,ACCESS	;      -  

	movf	POSTINC0,W,ACCESS	;       
	movff16	FSR0L,RAM_Str_Ptr	;     
		bra	Write_LCD			;  
;;       1 
;;    -    1  2 
;;     


RAM_Cmd_0x11		;    - 4 
	movlw	d'4'	;   
 rcall	Format_RAM_W;         

	lfsr	0,Ram_Str_Buf_0	;       
	movff	Format_Buf+1,Tmp_0	;     .
 rcall	Hex_Byte_Sub	;      
	movff	Format_Buf,Tmp_0	;     .
 rcall	Hex_Byte_Sub	;      
		bra	RAM_Str	;     

RAM_Cmd_0x12		;      - 2 
	movlw	d'2'	;   
;	rcall	Format_RAM		;     
 rcall	Format_RAM_W;         
	clrf	Format_Buf+1,ACCESS;   
 rcall	BIN_2_BCD; **************   6   +1:+3
	lfsr	0,Ram_Str_Buf_0	;       

	movff	Tmp_0+1,Tmp_0	;      .
		rcall	Hex_Byte_Sub	;      
		bra	RAM_Str	;     


RAM_Cmd_0x13;      - 6 

	movlw	d'5'	;    -  !!!
;       -     -  
;      -  .
;	rcall	Format_RAM;     
 		rcall	Format_RAM_W;         
 rcall	BIN_2_BCD; **************   6   +1:+3
	lfsr	0,Ram_Str_Buf_0	;       
	movff	Tmp_0+3,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      

	movff	Tmp_0+2,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      

	movff	Tmp_0+1,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      

	infsnz	RAM_Str_Ptr,F,BANKED;    
								;     
	incf	RAM_Str_Ptr+1,F,BANKED;   -     
		bra		RAM_Str	;     

RAM_Cmd_0x14		;     - 4 
	movlw	d'4'	;   
	;rcall	Format_RAM		;     
 		rcall	Format_RAM_W;         
	clrf	Format_Buf+1,0	;   
;      
;           - 
;     ,      =1
	btfss	Format_Buf,7,ACCESS	;     
		bra		Positive_Buf8		;    >=0
	bcf		LCD_Flg,7,ACCESS;   __ 
	comf	Format_Buf,F,ACCESS	;   2 
	incf	Format_Buf,F,ACCESS	;   
	bcf	Format_Buf,7,ACCESS;    -   
Positive_Buf8
 rcall	BIN_2_BCD; ***************   3   +1:+2
	lfsr	0,Ram_Str_Buf_0	;       

	movff	Tmp_0+2,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      

	movff	Tmp_0+1,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      
	movlf	0x20,Ram_Str_Buf_0,BANKED	;     
;      -     
	movlw	0x2D			;   "-"
	btfss	LCD_Flg,7,ACCESS;    - 
	movwf	Ram_Str_Buf_0,BANKED;      
	bsf		LCD_Flg,7,ACCESS;       	
		bra	RAM_Str	;     

;     -     28/02/2019
RAM_Cmd_Bra
 #ifdef	CompGoToTest
	subwf	TABLAT,W,ACCESS		;   
 call	CaseBra	;   WREG -     -  
;    2   BRA  RETLW
 #else
	subwf	TABLAT,F,ACCESS		;   
 BraReg	TABLAT,ACCESS;macro RegPoint,Adr1 ;    -  
 #endif
 	bra		RAM_Cmd_0x10	;    - 2  - 
	bra		RAM_Cmd_0x11	;    - 4  - 
	bra		RAM_Cmd_0x12	;      - 2  () - 
	bra		RAM_Cmd_0x13	;      - 5 
	bra		RAM_Cmd_0x14	;    
	bra		RAM_Cmd_0x15	;     - 6 
	bra		RAM_Cmd_0x16	;   -     -   .
	bra		RAM_Cmd_0x17	;    - :
	bra		RAM_Cmd_0x18	;    - 1   
	bra		RAM_Cmd_0x19	;    
							;      -127.7
	bra		RAM_Cmd_0x1A	;        / 
	bra		RAM_Cmd_0x1B 	;       . - 5  
	bra		RAM_Cmd_0x18;C    - 1   
	bra		RAM_Cmd_0x18;D    - 1   
	bra		RAM_Cmd_0x18;E    - 1   
	bra		RAM_Cmd_0x18;F    - 1   
	bra		RAM_Cmd_0x18		;    - 1   
;     -   28/02/2019 

RAM_Cmd_0x19	;    
;      -127.7
	movlw	d'6'	;   
	;rcall	Format_RAM		;     
 		rcall	Format_RAM_W;         
	;clrf	Format_Buf+1,ACCESS	;   
;      
;           - 
;     ,      =1
	btfss	Format_Buf+1,7,ACCESS;     
		bra		Positive_TempBuf16		;    >=0
	bcf		LCD_Flg,7,ACCESS;   __ 
	comf	Format_Buf,F,ACCESS	;   2 
	comf	Format_Buf+1,F,ACCESS	;   2 
	Inc16	Format_Buf,ACCESS	;   
	bcf	Format_Buf+1,7,ACCESS;    -   
Positive_TempBuf16		;    >=0   *10  /16
;     10    16
;Equation 6-1: 16 x 16 Unsigned Multiplication Algorithm
;RES3:RES2:RES1:RES0 = ARG1H:ARG1L  ARG2H:ARG2L
;= (ARG1H  ARG2H  2^16)+	;   
;(ARG1H  ARG2L  2^8)+		;    
;(ARG1L  ARG2H  2^8)+		;       
;(ARG1L  ARG2L)			;     
;    .
	clrf     Tmp_0+2,BANKED		;
	clrf     Tmp_0+3,BANKED		;	
	movf	Format_Buf,W,ACCESS	;
	mullw		d'10'	;     10
	movff16	PRODL,Tmp_0	;
	movf	Format_Buf+1,W,ACCESS	;
	mullw		d'10'	;     10
	Add16	Tmp_0+1,BANKED,PRODL,ACCESS	;     

	movlf	d'4',Tmp_0+3,BANKED	;  4  .
LoopTemp16
	bcf      _C			;
	rrcf     Tmp_0+2,F,BANKED			;R2   
	rrcf     Tmp_0+1,F,BANKED			;R1 
	rrcf     Tmp_0+0,F,BANKED			;R0   
	decfsz   Tmp_0+3, F,BANKED
		bra		LoopTemp16	;
	movff16	Tmp_0+0,Format_Buf	;    
 rcall	BIN_2_BCD; ***************   4   +1:+2

	lfsr	0,Ram_Str_Buf_0	;       
	movlw	0x20			;   " "
	movwf	POSTINC0,ACCESS	;     .

	movff	Tmp_0+2,Tmp_0	;     .
	rcall	Hex_Byte_Sub	;      
	
	swapf	Tmp_0+1,W,BANKED			;    .
		rcall	Hex_Nible_Sub	;  1  WREG   

	movlw	0x2E			;   "."
	movwf	POSTINC0,ACCESS	;    .

	movf	Tmp_0+1,W,BANKED;     .
		rcall	Hex_Nible_Sub	;  1  WREG   

;	movlf	0x20,Ram_Str_Buf_0,BANKED	;     
;      -     
	movlw	0x2D			;   "-"
	btfss	LCD_Flg,7,ACCESS;    - 
	movwf	Ram_Str_Buf_0,BANKED	;      


	bsf		LCD_Flg,7,ACCESS;       
		bra		RAM_Str;     

RAM_Cmd_0x15		;     - 6 
	movlw	d'6'	;   
;	rcall	Format_RAM		;     
 		rcall	Format_RAM_W;         
;      
;           - 
;     ,      =1
	btfss	Format_Buf+1,7,ACCESS	;     
	bra		Positive_Buf		;    >=0
	bcf		LCD_Flg,7,ACCESS	;   __ 
	comf	Format_Buf,F,ACCESS	;   2 
	comf	Format_Buf+1,F,ACCESS;   
	incfsz	Format_Buf,F,ACCESS	;   
	incf	Format_Buf+1,F,ACCESS;   
	bcf	Format_Buf+1,7,ACCESS;    -   
Positive_Buf
 rcall	BIN_2_BCD; *****************   6   +1:+3
	lfsr	0,Ram_Str_Buf_0	;       

	movff	Tmp_0+3,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      

	movff	Tmp_0+2,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      

	movff	Tmp_0+1,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      
	movlf	0x20,Ram_Str_Buf_0,BANKED	;     
;      -     
	movlw	0x2D			;   "-"
	btfss	LCD_Flg,7,ACCESS;    - 
	movwf	Ram_Str_Buf_0,BANKED;      
	bsf		LCD_Flg,7,ACCESS;       
		bra	RAM_Str;     

RAM_Cmd_0x16		;   -    - 1 
		rcall	Read_ROM_Byte	;     
	bcf		LCD_Flg,7,ACCESS;      -  
	movf	TABLAT,W,ACCESS	; 
	bsf		WREG,7,ACCESS	;    -    .
	bcf		LCD_RS		;    44780
		bra	Write_LCD		;   .
 ;bra		RAM_Str	;     
RAM_Cmd_0x17		;    ,  
	bsf		Flag1,2,ACCESS	;     
	bsf		Flag1,3,ACCESS	;     
		rcall	Read_ROM_Byte	;     
	movff	TABLAT,ParMin	; 
		rcall	Read_ROM_Byte	;     
	movff	TABLAT,ParMax	;
	bcf		Flag1,4,ACCESS	;  "  " 
	movf	ParMin,W,BANKED	;
	CPFSGT	ParMax,BANKED	; "  " -  
	bsf		Flag1,4,ACCESS	;  "  " 
		return ;         ?

;	bra		RAM_Str	;     
RAM_Cmd_0x1A		;       
; 18/01/2020      ,      
	bsf		LCD_Flg1,4,ACCESS	;  " " 
;movff16	LCD_Com,LCD_Com_SS	;	 
 rcall	Read_ROM_Byte	;       
	movff	TABLAT,LCD_Com	;     
 rcall	Read_ROM_Byte	;        
	movff	TABLAT,FSR0L	; 
 rcall	Read_ROM_Byte	;        
	movff	TABLAT,FSR0H	; 

;movff	INDF0,LCD_Com	;;    -  
	movf	INDF0,W,ACCESS	;
;	movwf	LCD_Com,ACCESS	;   - 
	addwf	LCD_Com,F,ACCESS;   

	clrf	LCD_Com+1,ACCESS;    / .
	;clrf	LCD_Pos,ACCESS	;   
	;incf	LCD_Pos,F,ACCESS;   -    

	movff16	Str_Ptr,Str_Ptr_SS;    -
;	movff	LCD_Flg,LCD_Flg_SS;     
	
 goto End_Command_SS	;         

RAM_Cmd_0x1B;       . - 5  

	movlw	d'5'	;    -  !!!
;       -     -  
;      -  .
;	rcall	Format_RAM;     
 		rcall	Format_RAM_W;         
 rcall	BIN_2_BCD; **************   6   +1:+3

	lfsr	0,Ram_Str_Buf_0	;       
	movff	Tmp_0+2,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      

	movlw	0x2E			;   "."
	movwf	POSTINC0,ACCESS	;    .

	movff	Tmp_0+1,Tmp_0	;     .
		rcall	Hex_Byte_Sub	;      

;	movff	Tmp_0+1,Tmp_0	;     .
;		rcall	Hex_Byte_Sub	;      

;	infsnz	RAM_Str_Ptr,F,BANKED;    
								;     
;	incf	RAM_Str_Ptr+1,F,BANKED;   -     
		bra		RAM_Str	;     


;	movlw	d'2'	;   
;	rcall	Format_RAM		;     
;	clrf	Format_Buf+1,ACCESS;   
; 	lfsr	0,Ram_Str_Buf_0	;       
;	movff	Tmp_0+1,Tmp_0	;      .
;	rcall	Hex_Byte_Sub	;      
;	bra		RAM_Str	;     
;
Hex_Byte_Sub	;       2   Tmp
				;        [FSR0]+   
				; - .
; -  /       .
	swapf	Tmp_0,W,BANKED			;    .
		rcall	Hex_Nible_Sub	;
;	andlw	0x0f			;   WREG 
;	addlw	0x30			;  
;	cpfsgt	Porog_9_A,BANKED;   9 > WREG	
;	addlw	0x7				;     
;	movwf	POSTINC0,ACCESS	;     .
	movf	Tmp_0,W,BANKED	;    
		rcall	Hex_Nible_Sub	;
;	andlw	0x0f			;   WREG 
;	addlw	0x30			;  
;	cpfsgt	Porog_9_A,BANKED;   9 > WREG	
;	addlw	0x7				;     
;	movwf	POSTINC0,ACCESS	;     .
		return

Hex_Nible_Sub	;  1     WREG
	andlw	0x0f			;   WREG 
	addlw	0x30			;  
	cpfsgt	Porog_9_A,BANKED;   9 > WREG	
	addlw	0x7				;     
	movwf	POSTINC0,ACCESS	;    .
		return