#define PCPWM_Present Yes	;  - 
#define PCPWM_Page		movlb	0x1	; BSR  Bank-1 for PCPWM 

#ifdef __DEBUG;*******   -    ?
 #define PCPWM_1PhCalc Yes	;     -  1   .
#else
 #define PCPWM_1PhCalc Yes	;    -  1   .
#endif

;      :
;#define b16_8full	; 16   8    
;#define b12_12half	; 12   12    
#define b9H8_12quart; 9  8  3*   12    
;#define b9H8_10quart; 9  8  3*   10       
;
#define PCPWM_CoSinus Yes	;  ~2        ~10 
#define PCPWM_12b	 Yes	; 12    8  -   
#define PCPWM_3H	 Yes	;  3    1/4   12  1/2  -   

#define PCPWM_DC_Corr Yes	;     DC -   
;#define PCPWM_Board Yes	;    /  
#define PCPWM_IRAMY Yes	;      ITRIP -   PWM .
;#define PCPWM_FreqHi Yes	; 11.7    11  (   12 ) - 
;     
;#define PCPWM_NoReverseKey Yes	;  ""   "   -0"

 #define FrqLen 6 ;   -  3   
;#define PCPWM_Dbg12b	 Yes	;  12   

IRAM_Stop macro		; 
; IRAMY       
;    2    RA0/An0  RA1/AN1
;  2        .
#ifdef	PCPWM_IRAMY ;;  IRAMX IRAMY    
	bcf		LATA,0,ACCESS	;     
	bcf		TRISA,0,ACCESS	;    
 #else	;  IRAMX
	bsf		LATA,0,ACCESS	;     
	bcf		TRISA,0,ACCESS	;    
 #endif
	endm	

ITRIP_Stop macro		;
	IRAM_Stop	; 2        .
;	bsf  PWMCON0,PMOD0,ACCESS ;;1 = PWM I/O pin pair (PWM0, PWM1) is in the Independent mode.
;	bsf  PWMCON0,PMOD1,ACCESS ;;1 = PWM I/O pin pair (PWM2, PWM3) is in the Independent mode.
;	bsf  PWMCON0,PMOD2,ACCESS ;;1 = PWM I/O pin pair (PWM4, PWM5) is in the Independent mode.
;	clrf OVDCOND,ACCESS	;0 = Output on PWM I/O pin is controlled by the value in the corresponding POUT bit.	
; clrf OVDCONS,ACCESS	;   
;
;	bcf  PWMCON0,PWMEN2,ACCESS ;;100 =PWM0, PWM1, PWM2, PWM3, PWM4 and PWM5 pins enabled for PWM output.
	clrf PWMCON0,ACCESS			;   
 setf	LATB,ACCESS	;   
	movlf	Init_TRISB,TRISB,ACCESS	;    	
 bcf PCPWM_Flag1,5,ACCESS;5=  /    (    )		
	endm	
PWM_Start macro		;
;  -   
	setf OVDCOND,ACCESS			;   
	clrf OVDCONS,ACCESS			;   
	clrf PWMCON0,ACCESS			;   
	bsf  PWMCON0,PWMEN2,ACCESS ;;100 =PWM0, PWM1, PWM2, PWM3, PWM4 and PWM5 pins enabled for PWM output.
	movff	DtConBuf,WREG		;   
	movwf	DTCON,ACCESS		;    WREG   
#ifdef	PCPWM_IRAMY ;;  IRAMX IRAMY    
	bcf		LATA,0,ACCESS	;     
 #else	;  IRAMX
	bsf		LATA,0,ACCESS	;     
 #endif
;    
;	nop
;	nop
;	nop
;	nop
	bsf		TRISA,0,ACCESS	;    
	endm	
MoveEditToWorkSpeed	 macro		;;    
 local	ADC_Speed,EndMacro	; 
	btfsc	PCPWM_Flag1,6,ACCESS;   ;6=   ADC-0   
	bra	ADC_Speed
 movff	PCPWM_WrkSpdBuf,PCPWM_WorkSpeed;****    
	bra	EndMacro
ADC_Speed
	movff ADC_Out+1,WREG	;    
	rrcf	WREG,W,ACCESS	;   2
	bcf		WREG,7,ACCESS	;    
	andlw	0x80	;      
	movff	WREG,PCPWM_WorkSpeed;
EndMacro
	endm	


#ifdef PCPWM_Board ;       
 ;       .
 ;#define PCPWM_StartVoltage 0x80
 ;          .
 #define PCPWM_StartCurrent 0xF2 
 ;        .
 #define PCPWM_StartTermistor 0xF2 
#else ;       - , , 
 ;       .
 ;#define PCPWM_StartVoltage 0xA0
 ;          .
 #define PCPWM_StartCurrent 0x2 
 ;        .
 #define PCPWM_StartTermistor 0xB2 
#endif


;; Pin and port:
;#define Beeper_TRIS		TRISD
;#define Beeper_Lat		LATD
;#define Beeper_Port		PORTD
;#define Beeper_Pin		4
;#define BeeperPin	 	Beeper_Lat,Beeper_Pin,ACCESS
;; Macros for sound:
;#define Beeper_Output	bcf	Beeper_TRIS,Beeper_Pin,ACCESS
;;#define Beeper_Input		bsf	Beeper_TRIS,Beeper_Pin,ACCESS
;;#define Beeper_Clear		bcf	BeeperPin
;;#define Beeper_Set		bsf	BeeperPin
;#define Beeper_Toggle	btg	BeeperPin

;
