;******************************************************************************
;    Filename: RTOS_Math.asm                                               *
;    Date:  27/03/2017                                                                   *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;       
;       .
;          
;     .
;     - .
;    -    
;         .
	#include Define.inc	;    
;*******************************
;    -   
 #ifdef	Math_Present
;*******************************
		Extern	InitAll
Math	code
		;      NOP
	goto	InitAll			;       - 
RecipTable;	
 #include Proj_Dir\Math\Reciprocal.inc	;   
;*******************************************
Math_Steps	;	   ""
	movf Math_Step,W,BANKED;	 ""
	sublw	d'10'	; Sub WREG from Literal
	bc	Math_EndCmd	;  ,  .
	BraReg	Math_Step,BANKED;	  "" 
 #include Proj_Dir\Math\Math_Task.inc	; BRA     
 global	Math_Task	;
Math_Task	;	
 Math_Page	; BSR for Math Task
	btfsc	Math_Flag,1,ACCESS	;     ?
		bra	Math_Steps	;	   ""
	bsf		Math_Flag,1,ACCESS	;   
;     - 8 ,   10-12
	movf Math_Cmd,W,ACCESS	;    - 
 bz		Math_Cmd0 ; 
	dcfsnz	WREG,W,ACCESS	
 bra	Math_Cmd1 ; 
	dcfsnz	WREG,W,ACCESS	
 bra	Math_Cmd2 ; 
	dcfsnz	WREG,W,ACCESS	
 bra	Math_Cmd3 ; 
Math_Cmd4 ;
	bcf		Math_Flag,1,ACCESS	;   
 bcf	Math_Flag,0,ACCESS	;   
	return	;
Math_Cmd0 ; 
	bcf		Math_Flag,1,ACCESS	;   
Math_Cmd1 ; 
	bcf		Math_Flag,1,ACCESS	;   
Math_Cmd2 ; 
	bcf		Math_Flag,1,ACCESS	;   
Math_Cmd3 ; 
Math_EndCmd	; 
	bcf		Math_Flag,1,ACCESS	;   
 bcf	Math_Flag,0,ACCESS	;   
 clrf	Math_Cmd,ACCESS		;
 clrf	Math_Step,BANKED	;
	return	;

;*******************************
;    -   
 #endif	; #ifdef	Math_Present
;*******************************

; #ifdef ADC_Present
; #endif
;

;End of program
		END

