; 25/01/2020 ; DeBug 8+1 bit
;   Help   USART 
;   bcf    TRISC,6      ; Make RC6 an output
;   movlw  19h          ; 9600 baud @4MHz
   movlw  0x01          ; / baud @ 48 MHz  
   movwf  SPBRG,ACCESS	; 	

   bsf    TXSTA,TXEN,ACCESS   ; Enable transmit
   bsf    TXSTA,BRGH,ACCESS   ; Select high baud rate
	bsf    BAUDCTL,BRG16,ACCESS; Select 16    baud rate
;  400-500    50 
   
   bsf    RCSTA,SPEN,ACCESS   ; Enable Serial Port
   bsf    RCSTA,CREN,ACCESS   ; Enable continuous reception

;	Extern	Table_Sinus
		PCPWM_Page	; BSR for PCPWM Task
	movlf	0x3A,DeBug_BufLcd+9,BANKED;    9    .
;	movlf	0x0,PCPWM_MK1+0,BANKED; .     12 	 
;	movlf	0x14,PCPWM_MK1+1,BANKED; .     12 	 

	movlf	0x50,DeBug_Counter,BANKED;     

	clrf	PCPWM_AmpSin+0,BANKED	;      V/F  
	clrf	PCPWM_AmpSin+1,BANKED	; 
	clrf	PCPWM_AmpSin3+0,BANKED	;  3    V/F
	clrf	PCPWM_AmpSin3+1,BANKED	;  3    V/F

	bra		DeBugLoopAmp
;   0x0D   0x0A    -   
;   .
HexNibSend
	andlw	0x0F					;    
	addlw	0x30					;
	cpfsgt	DeBug_BufLcd+9,BANKED;   9 > WREG	
	addlw	0x7				;     
ByteSend
	movwf	TXREG,ACCESS			;
	nop	;     USART
;	btfss	PIR1,TXIF,ACCESS	;    USART
	btfss	TXSTA,TRMT,ACCESS	;    
	bra		$-2					;
		return
SendHexWord	macro	ArgA,Adr1,Lit1
; 23/01/2020      -   .
	movlw	Lit1	;     
	rcall	ByteSend	; 

	swapf	ArgA+1,W,Adr1	;   - 
	rcall	HexNibSend	;   

	movf	ArgA+1,W,Adr1	;
	rcall	HexNibSend	;   

	swapf	ArgA+0,W,Adr1	;
	rcall	HexNibSend	;  

	movf	ArgA+0,W,Adr1	;
	rcall	HexNibSend	;  

 endm

DeBugLoopAmp:

	EXTERN	PDC_TableLoad	; 
 call	PDC_TableLoad		;


	clrf	DeBug_BufLcd+0,BANKED	;  
	clrf	DeBug_BufLcd+1,BANKED	; 16   

;	movlw	0x0D	;     
;	rcall	ByteSend	; 
	movlw	0x0A	;     
	rcall	ByteSend	; 

 SendHexWord	PCPWM_AmpSin+0,BANKED,"%"	; =====0====== PCPWM_AmpSin+0,BANKED
	;      V/F 
 SendHexWord	PCPWM_AmpSin3+0,BANKED,"@"	; =====0====== PCPWM_AmpSin3+0,BANKED
	;   3    V/F 

DeBugLoop:

	movlw	";";0x0D	;     
	rcall	ByteSend	; 
	movlw	0x0A	;     
	rcall	ByteSend	; 

; ============      =============
PDC_16L	equ	PDC0L 	;
PDC_16H	equ	PDC0H 	; 
Angle_8	equ	DeBug_BufLcd+1 ; 
	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory

NotSendSinus	;   2  

;	Inc16	DeBug_BufLcd+0,BANKED	;   
	Add16L	DeBug_BufLcd+0,BANKED,0x10	;   
;	movf	DeBug_BufLcd+1,W,BANKED	; 12   
;	andlw	0xF0					;    
;		bz	$+6		;  GoTo
		bnc	$+6		;  GoTo
	goto EndDeBugLoop			; 


;	movf	DeBug_BufLcd+1,W,BANKED	; 12   
;	andlw	0x0F					;    
;	movwf	DeBug_BufLcd+1,BANKED	;   
;	movwf	TBLPTRH,ACCESS			;  
;	movff	DeBug_BufLcd+0,TBLPTRL	;
;
;	btfss	TBLPTRL,0,ACCESS	;   -   
;		bra		NotSendSinus



; ===========      (     )

;;  12    16   - 9      .
;    3 
	 swapf	Angle_8-1,W,BANKED	;      
	andlw	0x0F	;    
	movwf	TBLPTRL,ACCESS	;    
	 swapf	Angle_8+0,W,BANKED	;        
	andlw	0xF0	;    
	iorwf	TBLPTRL,F,ACCESS	;      
	 swapf	Angle_8+0,W,BANKED	;        
		movwf	SynAdrH,BANKED;     	 3  
	andlw	0x03;0x0F	;      1/4 
	movwf	TBLPTRH,ACCESS	;      .
		movwf	Tbl3GPtrBuf+1,BANKED	;     .
 		movff	TBLPTRL,Tbl3GPtrBuf+0	;     .

;****************************************************************************************
; SendHexWord DeBug_BufLcd+0,BANKED,"&";=====00====== 
 movff	TBLPTRL+0,DeBug_BufLcd+2	
 movff	SynAdrH,DeBug_BufLcd+3	
 SendHexWord DeBug_BufLcd+2,BANKED,"&"; 	   12 
; SendHexWord DeBug_BufLcd+0,BANKED,"#";=====1======    
 SendHexWord TBLPTRL+0,ACCESS,"#";   	   
;****************************************************************************************


;****   3 
	btfsc	SynAdrH,2,BANKED	;	1/4 =    12  
		bra		Reverse3G		;    
	Add16L	TBLPTRL,ACCESS,Tab_Sin3G	;    
										;   3  
		bra 	DoneAdr3G
Reverse3G	;      / 
;	bcf		TBLPTRH,3,ACCESS	;	  12  
	movf	TBLPTRL,W,ACCESS	;
	sublw	low(Tab_Sin3G+0x400)		;   
	movwf	TBLPTRL,ACCESS		;
	movf	TBLPTRH,W,ACCESS	;  
	btfss	_C		;     
	incfsz	WREG,W,ACCESS	;      1,
	sublw	high(Tab_Sin3G+0x400);   
	movwf	TBLPTRH,ACCESS		;
DoneAdr3G	
	 tblrd*+	;         TABLAT


;****************************************************************************************
								;=====0====== 
 movff	TABLAT,DeBug_BufLcd+2	;	
 clrf	DeBug_BufLcd+3,BANKED	;
 btfsc	TABLAT,MSB,ACCESS		; 
 setf	DeBug_BufLcd+3,BANKED	; 	
 SendHexWord DeBug_BufLcd+2,BANKED,"~";=====0======	  3   
;****************************************************************************************


;         3 
;   (-127|+127)*(0|16448);  ()   
;  3  ( )  /   0x7f7f01 
;    MiddlePoint+0,BANKED
;  2  (     3 )   
;     -      
;  (0|127)*(0|16448) /   0x7f7f01
#define _Sign3G RevCalc_Flag,1,BANKED ;1=   3    
;  *  =  ,  toggle   .  -   
;  :
; 0. bcf; btfsc; btfsc -  ,   -
;            3 .
; 1. bcf; btfsc; btfsS -   -  ,  , .
; 2. bcf; btfsS; btfsc -   -  ,  , .
; 3. bcf; btfsS; btfsS -
; 4. bSf; btfsc; btfs -
; 5. bSf; btfsc; btfsS -   -  ,  ,  
; 6. bSf; btfsS; btfsc -
; 7. bSf; btfsS; btfsS -  ,  ,   
	bcf	_Sign3G	;   - 0= 1=
	btfsc 	TABLAT,MSB,ACCESS	;    
	btg	_Sign3G	;
	btfsc 	SynAdrH,3,BANKED	;     
	btg	_Sign3G	;
	btfsc 	TABLAT,MSB,ACCESS	;    
	negf 	TABLAT,ACCESS		; Sin = -1 * Sin  

; 3   
	movlf	0x01,SynMulBuf+0,BANKED	;   0  
	movlf	0x7F,SynMulBuf+1,BANKED	;   1  
	movlf	0x7F,SynMulBuf+2,BANKED	;   2  
;    0x7f7f01  .
;       
;        
;       *.

;     
;    
	movf 	TABLAT,W,ACCESS			;    
	mulwf	PCPWM_AmpSin3+0,BANKED;   3    V/F
	movf    PRODL,W,ACCESS			;   , 
				btfsc	_Sign3G			;    	
					bra	Sub3GFromMiddle	;    
 	addwf   SynMulBuf+0,f,BANKED	; Add 
	movf    PRODH,W,ACCESS			; products
 	addwfc  SynMulBuf+1,f,BANKED	;    
; 	clrf    WREG,ACCESS	;   
; 	addwfc   MiddlePoint+2,f,BANKED	;    
	btfsc	_C	;	    
	incf	SynMulBuf+2,f,BANKED	;    

;       1   
	movf 	TABLAT,W,ACCESS			;    
	mulwf	PCPWM_AmpSin3+1,BANKED;   3    V/F
	movf    PRODL,W,ACCESS			;   , 
 	addwf   SynMulBuf+1,f,BANKED	; Add cross
	movf    PRODH,W,ACCESS	; products
 	addwfc  SynMulBuf+2,f,BANKED	;       1 
; 	clrf    WREG,ACCESS	;   
; 	addwfc   MiddlePoint+3,f,BANKED	;     -  
; ***   3        .
		bra	DoneAdd3G2Middle

Sub3GFromMiddle
	subwf	SynMulBuf+0,F,BANKED;  Subtract WREG from f
	movf    PRODH,W,ACCESS			; products
	subwfb	SynMulBuf+1,F,BANKED;  Subtract WREG from f
	btfss	_C	;	 ,      
	decf	SynMulBuf+2,f,BANKED	;     


;       1   
	movf 	TABLAT,W,ACCESS			;    
	mulwf	PCPWM_AmpSin3+1,BANKED;   3    V/F
	movf    PRODL,W,ACCESS			;   , 
	subwf	SynMulBuf+1,F,BANKED	;  Subtract WREG from f
	movf    PRODH,W,ACCESS			; products
	subwfb	SynMulBuf+2,F,BANKED	;  Subtract WREG from f

DoneAdd3G2Middle
 movff	Tbl3GPtrBuf+0,TBLPTRL	;      .
 movff	Tbl3GPtrBuf+1,TBLPTRH	;      .
;****

;---
; btfss TBLPTRL,0,ACCESS	;   -   
;  bra NotSendSinus		;   -    
;---
;	bcf		TBLPTRL,0,ACCESS	;   -    


	btfsc	SynAdrH,2,BANKED	;	1/4 =    12  
		bra	Reverse	; 

	Add16L	TBLPTRL,ACCESS,Table_Sinus	;      

;#ifdef	PCPWM_CoSinus; Yes	;  ~2        ~10 
		bra DoneAdress
Reverse	;      / 
;	bcf		TBLPTRH,3,ACCESS	;	  12  
	movf	TBLPTRL,W,ACCESS	;
	sublw	low(Table_Sinus+0x400)		;   
	movwf	TBLPTRL,ACCESS		;
	movf	TBLPTRH,W,ACCESS	;  
	btfss	_C		;     
	incfsz	WREG,W,ACCESS	;      1,
	sublw	high(Table_Sinus+0x400);   
	movwf	TBLPTRH,ACCESS		;
DoneAdress
; *****     



;1)   :
 tblrd*+	;       
	movf	TABLAT,W,ACCESS	;   8+1  
	mullw	0x08			;   8+1  12 
	movff16	PRODL,SynMulBuf+6;  -   

;****************************************************************************************
; movff16	PRODL,DeBug_BufLcd+6;,BANKED; ********  USART
;  movwf	DeBug_BufLcd+7,BANKED; ********  USART
;  clrf	DeBug_BufLcd+7,BANKED; ********  USART
 SendHexWord	PRODL,ACCESS,"=" ;=====2======     
 ;****************************************************************************************

 movf	PRODL,W,ACCESS	;   16  
 mulwf	PCPWM_AmpSin+0,BANKED;      V/F  
 movf   PRODL,W,ACCESS			;   , 
	btfsc	SynAdrH,3,BANKED	;	1/4 =    12  
		bra	SubFromMiddle	; 
 	addwf   SynMulBuf+0,f,BANKED	; Add 
	movf    PRODH,W,ACCESS			; products
 	addwfc  SynMulBuf+1,f,BANKED	;    
	btfsc	_C	;	    
	incf	SynMulBuf+2,f,BANKED	;    

; tblrd*+	;    
;2)   :
	movf	SynMulBuf+7,W,BANKED	;   16   <0x10
 mulwf	PCPWM_AmpSin+1,BANKED;      <0x10
	movf   PRODL,W,ACCESS		 ;   , 
 	addwf   SynMulBuf+2,f,BANKED	; Add 
;	movf    PRODH,W,ACCESS			; products					; 
; 	addwfc  SynMulBuf+1,f,BANKED	;    	;  
;	btfsc	_C	;	    				; 
;	incf	SynMulBuf+2,f,BANKED	;    		; 
	
;   .

;3)  Sin   Amp,    
	movf	SynMulBuf+7,W,BANKED	;   16   <0x10
 mulwf	PCPWM_AmpSin+0,BANKED;      V/F  
	movf   PRODL,W,ACCESS		 ;   , 
 	addwf   SynMulBuf+1,f,BANKED	; Add 
	movf    PRODH,W,ACCESS			; products					
 	addwfc  SynMulBuf+2,f,BANKED	;    	
;	btfsc	_C	;	    				; 
;	incf	SynMulBuf+3,f,BANKED	;    		; 
		 
;4)  Sin   Amp,    
	movf	SynMulBuf+6,W,BANKED;  Sin 
 ;movf	TABLAT,W,ACCESS	;   8+1  
 mulwf	PCPWM_AmpSin+1,BANKED;     
	movf   PRODL,W,ACCESS		 ;   , 
 	addwf   SynMulBuf+1,f,BANKED	; Add 
	movf    PRODH,W,ACCESS			; products					
 	addwfc  SynMulBuf+2,f,BANKED	;    	
;	btfsc	_C	;	    				; 
;	incf	SynMulBuf+3,f,BANKED	;    		; 
		bra	ExitMul

SubFromMiddle ;   
 	subwf   SynMulBuf+0,f,BANKED	; Subtract WREG from f  
	movf    PRODH,W,ACCESS			; products
 	subwfb  SynMulBuf+1,f,BANKED	;    
	btfss	_C	;	 ,      
	decf	SynMulBuf+2,f,BANKED	;     

; tblrd*+	;    
;2)   :
	movf	SynMulBuf+7,W,BANKED	;   16   <0x10
 mulwf	PCPWM_AmpSin+1,BANKED;      <0x10
	movf   PRODL,W,ACCESS		 ;   , 
 	subwf   SynMulBuf+2,f,BANKED	; Subtract WREG from f  
;	movf    PRODH,W,ACCESS			; products					; 
; 	subwfc  SynMulBuf+1,f,BANKED	;    	;  
;	btfss	_C	; ,     ; 
;	decf	SynMulBuf+2,f,BANKED	;    		; 
	
;     .

;3)  Sin   Amp,    
	movf	SynMulBuf+7,W,BANKED	;   16   <0x10
 mulwf	PCPWM_AmpSin+0,BANKED;      V/F  
	movf   PRODL,W,ACCESS		 ;   , 
 	subwf   SynMulBuf+1,f,BANKED	; Subtract WREG from f  
	movf    PRODH,W,ACCESS			; products					
 	subwfb  SynMulBuf+2,f,BANKED	;    	
;	btfsc	_C	;	    				; 
;	incf	SynMulBuf+3,f,BANKED	;    		; 
		 
;4)  Sin   Amp,    
	movf	SynMulBuf+6,W,BANKED;  Sin 
 ;movf	TABLAT,W,ACCESS	;   8+1  
 mulwf	PCPWM_AmpSin+1,BANKED;     
	movf   PRODL,W,ACCESS		 ;   , 
 	subwf   SynMulBuf+1,f,BANKED	; Subtract WREG from f 
	movf    PRODH,W,ACCESS			; products					
 	subwfb  SynMulBuf+2,f,BANKED	;    	
ExitMul

;        23 

;#ifdef __DEBUG;*******   
;	movf	SynMulBuf+0,W,BANKED;     
;	movf	SynMulBuf+1,W,BANKED;  0  
;	movf	SynMulBuf+2,W,BANKED;  1  
;	movf	SynMulBuf+3,W,BANKED;    = 0  
; #endif

;****************************************************************************************
 SendHexWord	SynMulBuf+1,BANKED,"*" ; =====3======   *      
;****************************************************************************************

; 16          ,    .
;       0.
;  16     11-12   -    16 , 
;  32    11-12  
;    1/10     
	movlw	low(0xFFFF/0xA);,W	,A1A	;   10%  0xFFFF
	subwf	SynMulBuf+1,F,BANKED		;    ,  : =B-A

	movlw	high(0xFFFF/0xA);,W,A1A		;  , 10%  0xFFFF
;	btfss	_C		;     
;	incfsz	ArgA+1,W,A1A	;      1,
	subwfb	SynMulBuf+2,F,BANKED	;     -   
 #ifdef	PCPWM_Board; Yes	;    /  
		bnc	ZeroPoint	;  -       
 #else
		bnc	BotWithoutPWM;  -     
 #endif
;    1/5       
	movlw	low(0xFFFF-0xFFFF/0x5);,W	,A1A	;   10%  0xFFFF
	subwf	SynMulBuf+1,W,BANKED		;      

	movlw	high(0xFFFF-0xFFFF/0x5);,W,A1A		;  , 10%  0xFFFF
	subwfb	SynMulBuf+2,W,BANKED	;     -   
		bc	MaxPoint	;   -  

;****************************************************************************************
 SendHexWord	SynMulBuf+1,BANKED,"+" ; =====4======  /    *   
;****************************************************************************************

;     ,         11  
; PCPWM_MK1+0   \Init_PCPWM_3F.inc:217
 ;FXM1616U2 macro D_Arg,A1D,A_Arg,A1A,B_Arg,A1B,_Work,A1W; ;    -  
; FXM1616U2	SynMulBuf+4,	bnk,	SynMulBuf+1,	bnk,	PCPWM_MK1+0,	bnk,	SynMulBuf+0,	bnk;	  
; FXM1680U	SynMulBuf+4,	bnk,	SynMulBuf+1,	bnk,	PCPWM_MK1+0,	bnk;,	SynMulBuf+0,	bnk;	  
  FXM1680U2	SynMulBuf+4,	bnk,	SynMulBuf+1,	bnk,	PCPWM_MK1+0,	bnk;,	SynMulBuf+0,	bnk;	  
	movff	PRODL,PDC_16L	;  
	movff	PRODH,PDC_16L-1	;  
;	movff	SynMulBuf+6,PDC_16L		;  
;	movff	SynMulBuf+7,PDC_16L-1	;  

;****************************************************************************************
 movff	PRODL,DeBug_BufLcd+4 ;  
 movff	PRODH,DeBug_BufLcd+5 ;  
;****************************************************************************************

		bra		Done

MaxPoint:
; 05/01/2019      
;    PDC=4*PTPer-DTCon -    DT -  
;      ~ 0.1 .
;PcPwmPdcMax	:2;F,BANKED;  PDC   -  

; movf	DTCON,W,ACCESS	;  #1 - Dead Time Unit
 movf	PcPwmTopDT,W,BANKED;  #2 =        
 		bz	TopWithoutCharge	;    -   
 movff	PcPwmPdcMax+1,SynMulBuf+0	;     
 subwf	PcPwmPdcMax+0,W,BANKED	; ,   
 btfss	_C	;  
 	decf	SynMulBuf+0,F,BANKED	;  
 bsf	_C	;   
 subfwb	DTCON,W,ACCESS	;  #1 - Dead Time Unit
			;    
 btfss	_C	;  
 	decf	SynMulBuf+0,F,BANKED	;  

 movwf	PDC_16L,ACCESS			; .  
 movff	SynMulBuf+0,PDC_16L-1;,ACCESS		; .  

;****************************************************************************************
 movwf DeBug_BufLcd+4,BANKED; .    
 movff SynMulBuf+0,DeBug_BufLcd+5;,BANKED; .    
;****************************************************************************************
		bra		Done

TopWithoutCharge
	movff	PcPwmPdcMax+0,PDC_16L;,ACCESS; .  
	movff	PcPwmPdcMax+1,PDC_16L-1;,ACCESS; .  

;****************************************************************************************
 movff PcPwmPdcMax+0,DeBug_BufLcd+4;,BANKED; .    
 movff PcPwmPdcMax+1,DeBug_BufLcd+5;,BANKED; .    
;****************************************************************************************

		bra		Done
ZeroPoint:	;   =0,      
;     PDC -    DTCON -    
;    DT.
;    PDC=DTCon -    DT -  
;      ~ 0.1 .
; *****       DT - ***  ***  .*****
;    -         DT.
;
 clrf	SynMulBuf+0,BANKED	;     
 movf	PcPwmTopDT,W,BANKED;  #1 =        
 		bz	BotWithoutPWM	;    -   
 addwf	DTCON,W,ACCESS	;  2
 btfsc	_C	;
 	incf	SynMulBuf+0,F,BANKED	;     

 movwf	PDC_16L,ACCESS	;  
 movff	SynMulBuf+0,PDC_16L-1;,ACCESS; . 

;****************************************************************************************
 movwf DeBug_BufLcd+4,BANKED; . ZeroPoint  
 movff SynMulBuf+0,DeBug_BufLcd+5;,BANKED; . ZeroPoint  
;****************************************************************************************


; movlf	0x19,PDC_16L,ACCESS	;  
		bra		Done
BotWithoutPWM
	clrf	PDC_16L,ACCESS	;  
	clrf	PDC_16L-1,ACCESS	;;  

;****************************************************************************************
	clrf	DeBug_BufLcd+4,BANKED	;  
	clrf	DeBug_BufLcd+5,BANKED	;  
;****************************************************************************************

Done:

;****************************************************************************************
; 23/01/2020          -   
; movff	PDC_16L,DeBug_BufLcd+4		;  
; movff	PDC_16L-1,DeBug_BufLcd+5	;  
 SendHexWord	DeBug_BufLcd+4,BANKED,"$";=====5======   PDC
;****************************************************************************************

						goto	DeBugLoop	
; 	SinTabLdDbg	 Angle_1+2,PDC0L	;      

EndDeBugLoop
;   .
	decfsz DeBug_Counter,F,BANKED;    
 bra	Inc16Amp
	incf	DeBug_Counter,F,BANKED;  

	Add16L	PCPWM_AmpSin+0,BANKED,0xD ;    
	
 bra	DoneAddAmp

Inc16Amp
	Inc16	PCPWM_AmpSin+0,BANKED	; ;    
;	infsnz	PCPWM_AmpSin3,F,BANKED;  3    V/F
;	decf	PCPWM_AmpSin3,F,BANKED; 0xFF  

DoneAddAmp
	
;  2  -   3 .    
; 3   0  1      
; 3.  3  (0|16448) /   .
;   (0|0xFFF)  2/5= 1638   3  = 0.
;     (1638|4095-1638=0|2457)*6.6943 = (0|16448).
;    16b*16b=32/16b    6.6943*256=1713.74  .
;       ( 0xCCC=3276)  3  
;= - 1638 = 1638 * 1714 = 2 807 532 / 256 = 10 966.92 = 2/3  |2/12  .
; 2/12  3/12  2/3 -   .
; 13/03/2020    3H        
;  https://pdfs.semanticscholar.org/680c/730a9a184c8b54fa036cc19c980afe192274.pdf
; J. Holtz "Pulsewidth Modulation for Electronic Power Conversion"
;   3 ~ 2950 ~ 2/3   
;   3 ~ 3359 ~ 82%   -   3  0.8
;   3 ~ 3180 ~ 77%   
;      (1 ~= 0.9) -  3H ~= 1/8~1/7 ~= 7569 8650
;    3 ~= 13 107 ~ 13 158 ~= 1/5   

	movff16	PCPWM_AmpSin,SynMulBuf+0	;    
;	Sub16L	SynMulBuf+0,BANKED,d'1638'	;    3 
	Sub16L	SynMulBuf+0,BANKED,d'3180'	; 13/03/2020   3 
		bc		NonZeroAmp3	;  
;   (0|0xFFF)  2/5= 1638   3  = 0.
	clrf	PCPWM_AmpSin3+0,BANKED	;  3    V/F
	clrf	PCPWM_AmpSin3+1,BANKED	;  3    V/F
		bra		DoneAmp3
NonZeroAmp3	
;     (1638|4095-1638=0|2457)*6.6943 = (0|16448).
;    16b*16b=32/16b    6.6943*256=1713.74  .
; #define MultiplAmp3H		d'1713'

; 13/03/2020   (3180|4095-3180=0|915)*14.3246 = (0|13107).
;    16b*16b=32/16b    14.3246*256=3667,095  .
 #define MultiplAmp3H		d'3667'

;   SynMulBuf+2 : PCPWM_AmpSin3+0 : PCPWM_AmpSin3+1     
	movlw	low(MultiplAmp3H)	;   
  mulwf		SynMulBuf+0,BANKED	; 
	movff	PRODL,SynMulBuf+2	;  
	movff	PRODH,PCPWM_AmpSin3+0;  
	movlw	high(MultiplAmp3H)	;   
  mulwf		SynMulBuf+1,BANKED	; 
	movff	PRODL,PCPWM_AmpSin3+1	;  ,    
	movlw	low(MultiplAmp3H)	;    
   mulwf	SynMulBuf+1,BANKED	; 
; ArgB,A1B,ArgA,A1A	;   -  ;   B=B+A 
  Add16	PCPWM_AmpSin3+0,BANKED,PRODL,ACCESS;    
	movlw	high(MultiplAmp3H)	;     
  mulwf		SynMulBuf+0,BANKED	; 
  Add16	PCPWM_AmpSin3+0,BANKED,PRODL,ACCESS;    
;  PCPWM_AmpSin3   (0|16440) .
DoneAmp3

	movf	PCPWM_AmpSin+1,W,BANKED	;  
	andlw	0xF0					;    
		bnz	$+6
 	goto	DeBugLoopAmp	

	nop
	nop
	halt
	sleep
	bra $-2
