;  Int_PCPWM_3H_x431.inc		Include for:
;    Filename: RTOS_Interrupt.asm                 *
 #include Proj_Dir\PCPWM_3F\PDC_3H_Macro.inc;   
		Extern	Tab_Sin3G,Table_Sinus,Tab_SinEnd	;	;   PcPWM 

; 1. ****   -  16    12 ,  
;      
	Con16v12b TBLPTRL,ACCESS,Angle_1+1,BANKED	;     
;       

;		movwf	SynAdrH,BANKED;     	 3  
;	andlw	0x03;0x0F	;      1/4 
;	movwf	TBLPTRH,ACCESS	;      .
		movwf	Tbl3GPtrBuf+1,BANKED	;     .
 		movff	TBLPTRL,Tbl3GPtrBuf+0	;     .

;2. ****   3 
	btfsc	SynAdrH,2,BANKED	;	1/4 =    12  
		bra		Reverse3G		;    
	Add16L	TBLPTRL,ACCESS,Tab_Sin3G	;    
										;   3  
		bra 	DoneAdr3G
Reverse3G	;      / 
;	bcf		TBLPTRH,3,ACCESS	;	  12  
	movf	TBLPTRL,W,ACCESS	;
	sublw	low(Tab_Sin3G+0x400)		;   
	movwf	TBLPTRL,ACCESS		;
	movf	TBLPTRH,W,ACCESS	;  
	btfss	_C		;     
	incfsz	WREG,W,ACCESS	;      1,
	sublw	high(Tab_Sin3G+0x400);   
	movwf	TBLPTRH,ACCESS		;
DoneAdr3G	
	 tblrd*+	;         TABLAT

;		movff	TABLAT,DeBug_Test3G+0	; 	

		
;3. **** 
;         3 
;   (-127|+127)*(0|16448);  ()   
;  3  ( )  /   0x7f7f01 
;    MiddlePoint+0,BANKED
;  2  (     3 )   
;     -      
;  (0|127)*(0|16448) /   0x7f7f01
#define _Sign3G RevCalc_Flag,1,BANKED ;1=   3    
;  *  =  ,  toggle   .
	bcf	_Sign3G	;   - 0= 1=
	btfsc 	TABLAT,MSB,ACCESS	;    
	btg	_Sign3G	;
	btfsc 	SynAdrH,3,BANKED	;     
	btg	_Sign3G	;
	btfsc 	TABLAT,MSB,ACCESS	;    
	negf 	TABLAT,ACCESS		; Sin = -1 * Sin  



;4.***** 				3    - 
;	    
;     -      .
;        DTCON
	movlf	0x01,SynMulBuf+0,BANKED	;   0  
	movlf	0x7F,SynMulBuf+1,BANKED	;   1  
	movlf	0x7F,SynMulBuf+2,BANKED	;   2  
;    0x7f7f01  .
;       
;        
;       *.

;5. ******      
;5    
	movf 	TABLAT,W,ACCESS			;    
	mulwf	PCPWM_AmpSin3+0,BANKED;   3    V/F
	movf    PRODL,W,ACCESS			;   , 
				btfsc	_Sign3G			;    	
					bra	Sub3GFromMiddle	;    
 	addwf   SynMulBuf+0,f,BANKED	; Add 
	movf    PRODH,W,ACCESS			; products
 	addwfc  SynMulBuf+1,f,BANKED	;    
; 	clrf    WREG,ACCESS	;   
; 	addwfc   MiddlePoint+2,f,BANKED	;    
	btfsc	_C	;	    
	incf	SynMulBuf+2,f,BANKED	;    

;5       1   
	movf 	TABLAT,W,ACCESS			;    
	mulwf	PCPWM_AmpSin3+1,BANKED;   3    V/F
	movf    PRODL,W,ACCESS			;   , 
 	addwf   SynMulBuf+1,f,BANKED	; Add cross
	movf    PRODH,W,ACCESS	; products
 	addwfc  SynMulBuf+2,f,BANKED	;       1 
; 	clrf    WREG,ACCESS	;   
; 	addwfc   MiddlePoint+3,f,BANKED	;     -  
; ***   3        .
		bra	DoneAdd3G2Middle

;5-1
Sub3GFromMiddle
	subwf	SynMulBuf+0,F,BANKED;  Subtract WREG from f
	movf    PRODH,W,ACCESS			; products
	subwfb	SynMulBuf+1,F,BANKED;  Subtract WREG from f
	btfss	_C	;	 ,      
	decf	SynMulBuf+2,f,BANKED	;     

;5-1
;       1   
	movf 	TABLAT,W,ACCESS			;    
	mulwf	PCPWM_AmpSin3+1,BANKED;   3    V/F
	movf    PRODL,W,ACCESS			;   , 
	subwf	SynMulBuf+1,F,BANKED	;  Subtract WREG from f
	movf    PRODH,W,ACCESS			; products
	subwfb	SynMulBuf+2,F,BANKED	;  Subtract WREG from f

DoneAdd3G2Middle
 movff	Tbl3GPtrBuf+0,TBLPTRL	;      .
 movff	Tbl3GPtrBuf+1,TBLPTRH	;      .
;   / .

 #ifdef	PCPWM_1PhCalc	;    -  1   
;  3  .

	dcfsnz	SynFaza,F,BANKED	; 
	 bra		Faza_1 ; -1
	movf	SynFaza,W,BANKED	; 
	dcfsnz	WREG,W,ACCESS		;  
	 bra		Faza_2 ; -2
	dcfsnz	WREG,W,ACCESS		;   
	 bra		Faza_3 ; -3
;    3    	
Faza_1 ; -1
	movlf	0x3,SynFaza,BANKED	;   
 #else ;#ifdef	PCPWM_1PhCalc	;
  movff24	SynMulBuf,Syn3HBuf	;     3 
 #endif;#ifdef	PCPWM_1PhCalc	;;    -  1   . #else

;   -     TBLPTRL,  -     
 Sin2PdcLoad	PDC0L	;	      PWM-0

 #ifdef	PCPWM_1PhCalc	;   
	bra	DonePwm3H	;	return	;  -  1  
Faza_2 ; -2
 #else ;#ifdef	PCPWM_1PhCalc	;
	movff24	Syn3HBuf,SynMulBuf	;     3 
 #endif;#ifdef	PCPWM_1PhCalc	;  .
 
 Add24S3 Angle_2,BANKED,Angle_1,BANKED,PcPwmAngle_1,BANKED	; D=B+A       +1/3 	
 Con16v12b TBLPTRL,ACCESS,Angle_2+1,BANKED	;      -   TBLPTR
 Sin2PdcLoad	PDC1L	;	      PWM-1

 #ifdef	PCPWM_1PhCalc	;   
	bra	DonePwm3H	;	return	;  -  1  
Faza_3 ; -3
 #else ;#ifdef	PCPWM_1PhCalc	;
	movff24	Syn3HBuf,SynMulBuf	;     3 
 #endif;#ifdef	PCPWM_1PhCalc	;  .
 
 Add24S3 Angle_2,BANKED,Angle_1,BANKED,PcPwmAngle_2,BANKED	; D=B+A       +2/3 	
 Con16v12b TBLPTRL,ACCESS,Angle_2+1,BANKED	;      -   TBLPTR
 Sin2PdcLoad	PDC2L	;	      PWM-2

DonePwm3H	; 

; call	DelayCuriosity	;	    
;      3  1/4      
;   5    10 ,  7   7-8  , E= .
;  ~0.6  , 1.5  -   .
; 07/08/2020      - 0x30    1   10 
; 0x3A = 
;    12     0x12   5 , 
; 0x1E = 
;  1      0x3E   10 , 0x48=
