;******************************************
;    Filename: PCPWM_3F_4431.asm           *
;    Date:                                *
;    File Version: 000.001                *
;    Author: PSW.RU                       *
;    Company: Labs                        *
	#include Define.h	;     
;*******************************
;    -   
;*******************************
 #ifdef	PCPWM_Present

	global	SpeedCalc,SpeedChange,StopMotor,MotorFault
	global	RevCalc;,DelayCuriosity ;   .
;	global	PDC_TableLoad;,DelayCuriosity ;   .

	Extern	InitAll,TabPwmFreq,TabDeltAngle,Table_Sinus,Tab_SinEnd		;
	Extern	Table_Simples	;
	Extern	Restore_ML


;******************************************
PCPWM	code
;       - 
	movlw	0x21	;    
 call	Restore_ML	;        
	
; SpeedCalc	;     100 
; rcall	PDC_TableLoad		;   
 #include Proj_Dir\PCPWM_3F\SpeedCalc.inc	;  -   

;SpeedChange	;   /   / PCPWM 
 #include Proj_Dir\PCPWM_3F\SpeedChange.inc	;  -   
	retlw	0x15	;  -    

RevCalc	;
 #include Proj_Dir\PCPWM_3F\Rev_Calc.inc	;  -   

 

;SinTabLd	;      SinTableLoad	macro 
; #include Proj_Dir\PCPWM_3F\SinTabLd.inc;   
;	return

;PCPWM_Task	;  PCPWM 11.7/23.4/18.75 	
;;*******************************************
;		PCPWM_Page	; BSR for PCPWM Task
;	BSF EECON1, EEPGD,ACCESS	; Point to PROGRAM memory
;
;	
;; #include Proj_Dir\PCPWM_3F\PDC_TableLoad.inc;    
;;  3  -  .  -  1  3 .
;
;
; #ifdef	PCPWM_1PhCalc	;;    -  1   .
;	dcfsnz	SynFaza,F,BANKED	; 
;	 bra		Faza_1 ; -1
;	movf	SynFaza,W,BANKED	; 
;	dcfsnz	WREG,W,ACCESS		;  
;	 bra		Faza_2 ; -2
;	dcfsnz	WREG,W,ACCESS		;   
;	 bra		Faza_3 ; -3
;;    3    	
;Faza_1 ; -1
;	movlf	0x3,SynFaza,BANKED	;   
; #endif;#ifdef	PCPWM_1PhCalc	;;    -  1   . #else
;
;; #ifdef PCPWM_Dbg12b	; Yes	;  12   
;; 	SinTabLdDbg	 Angle_1+2,PDC0L	;      
;; #else
;	SinTableLoad Angle_1+2;,PDC0L	;      
;
;	movff	PRODL,PDC0L	;  
;	movff	PRODH,PDC0L-1	;  
; 
;; #endif
;
; #ifdef	PCPWM_1PhCalc	;   
;	return				;  -  1  
; #endif					;  .
;Faza_2 ; -2
;
;; Add24L3 Angle_2,BANKED,Angle_1,BANKED,0x555555	; D=B+A       +1/3 	
; Add24S3 Angle_2,BANKED,Angle_1,BANKED,PcPwmAngle_1,BANKED	; D=B+A       +1/3 	
;
;; #ifdef PCPWM_Dbg12b ;	 Yes	;  12   
;;	movlf	0x4,PDC1L,ACCESS	;   
;;	movlf	0x4,PDC1H,ACCESS	; 
;; #else
; SinTableLoad	Angle_2+2;,PDC1L	;      
;
;	movff	PRODL,PDC1L	;  
;	movff	PRODH,PDC1L-1	;  
;
;; #endif
;
; #ifdef	PCPWM_1PhCalc	;   
;	return				;  -  1  
; #endif					;  .
;
;Faza_3 ; -3
;
;; Add24L3 Angle_3,BANKED,Angle_1,BANKED,0xAAAAAA	; D=B+A       +2/3 
; Add24S3 Angle_2,BANKED,Angle_1,BANKED,PcPwmAngle_2,BANKED	; D=B+A       +1/3 	
; SinTableLoad	Angle_2+2;,PDC2L	;      
;	movff	PRODL,PDC2L	;  
;	movff	PRODH,PDC2L-1	;  
;
;
;;********************		return	; ***********************

; call	DelayCuriosity	;	    

;
;;*******************************
;    -   
;*******************************
 #endif ;ifdef	PCPWM_Present
;End of program
		END
